<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfCabinClassDisplay ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfCabinClassDisplay
 * @subpackage Arrays
 */
class ArrayOfCabinClassDisplay extends AbstractStructArrayBase
{
    /**
     * The CabinClassDisplay
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\CabinClassDisplay[]
     */
    public $CabinClassDisplay;
    /**
     * Constructor method for ArrayOfCabinClassDisplay
     * @uses ArrayOfCabinClassDisplay::setCabinClassDisplay()
     * @param \StructType\CabinClassDisplay[] $cabinClassDisplay
     */
    public function __construct(array $cabinClassDisplay = array())
    {
        $this
            ->setCabinClassDisplay($cabinClassDisplay);
    }
    /**
     * Get CabinClassDisplay value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\CabinClassDisplay[]|null
     */
    public function getCabinClassDisplay()
    {
        return isset($this->CabinClassDisplay) ? $this->CabinClassDisplay : null;
    }
    /**
     * This method is responsible for validating the values passed to the setCabinClassDisplay method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCabinClassDisplay method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCabinClassDisplayForArrayConstraintsFromSetCabinClassDisplay(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfCabinClassDisplayCabinClassDisplayItem) {
            // validation for constraint: itemType
            if (!$arrayOfCabinClassDisplayCabinClassDisplayItem instanceof \StructType\CabinClassDisplay) {
                $invalidValues[] = is_object($arrayOfCabinClassDisplayCabinClassDisplayItem) ? get_class($arrayOfCabinClassDisplayCabinClassDisplayItem) : sprintf('%s(%s)', gettype($arrayOfCabinClassDisplayCabinClassDisplayItem), var_export($arrayOfCabinClassDisplayCabinClassDisplayItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The CabinClassDisplay property can only contain items of type \StructType\CabinClassDisplay, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set CabinClassDisplay value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\CabinClassDisplay[] $cabinClassDisplay
     * @return \ArrayType\ArrayOfCabinClassDisplay
     */
    public function setCabinClassDisplay(array $cabinClassDisplay = array())
    {
        // validation for constraint: array
        if ('' !== ($cabinClassDisplayArrayErrorMessage = self::validateCabinClassDisplayForArrayConstraintsFromSetCabinClassDisplay($cabinClassDisplay))) {
            throw new \InvalidArgumentException($cabinClassDisplayArrayErrorMessage, __LINE__);
        }
        if (is_null($cabinClassDisplay) || (is_array($cabinClassDisplay) && empty($cabinClassDisplay))) {
            unset($this->CabinClassDisplay);
        } else {
            $this->CabinClassDisplay = $cabinClassDisplay;
        }
        return $this;
    }
    /**
     * Add item to CabinClassDisplay value
     * @throws \InvalidArgumentException
     * @param \StructType\CabinClassDisplay $item
     * @return \ArrayType\ArrayOfCabinClassDisplay
     */
    public function addToCabinClassDisplay(\StructType\CabinClassDisplay $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\CabinClassDisplay) {
            throw new \InvalidArgumentException(sprintf('The CabinClassDisplay property can only contain items of type \StructType\CabinClassDisplay, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->CabinClassDisplay[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\CabinClassDisplay|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\CabinClassDisplay|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\CabinClassDisplay|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\CabinClassDisplay|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\CabinClassDisplay|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string CabinClassDisplay
     */
    public function getAttributeName()
    {
        return 'CabinClassDisplay';
    }
}
