<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfDeckDisplay ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfDeckDisplay
 * @subpackage Arrays
 */
class ArrayOfDeckDisplay extends AbstractStructArrayBase
{
    /**
     * The DeckDisplay
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DeckDisplay[]
     */
    public $DeckDisplay;
    /**
     * Constructor method for ArrayOfDeckDisplay
     * @uses ArrayOfDeckDisplay::setDeckDisplay()
     * @param \StructType\DeckDisplay[] $deckDisplay
     */
    public function __construct(array $deckDisplay = array())
    {
        $this
            ->setDeckDisplay($deckDisplay);
    }
    /**
     * Get DeckDisplay value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DeckDisplay[]|null
     */
    public function getDeckDisplay()
    {
        return isset($this->DeckDisplay) ? $this->DeckDisplay : null;
    }
    /**
     * This method is responsible for validating the values passed to the setDeckDisplay method
     * This method is willingly generated in order to preserve the one-line inline validation within the setDeckDisplay method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateDeckDisplayForArrayConstraintsFromSetDeckDisplay(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfDeckDisplayDeckDisplayItem) {
            // validation for constraint: itemType
            if (!$arrayOfDeckDisplayDeckDisplayItem instanceof \StructType\DeckDisplay) {
                $invalidValues[] = is_object($arrayOfDeckDisplayDeckDisplayItem) ? get_class($arrayOfDeckDisplayDeckDisplayItem) : sprintf('%s(%s)', gettype($arrayOfDeckDisplayDeckDisplayItem), var_export($arrayOfDeckDisplayDeckDisplayItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The DeckDisplay property can only contain items of type \StructType\DeckDisplay, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set DeckDisplay value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\DeckDisplay[] $deckDisplay
     * @return \ArrayType\ArrayOfDeckDisplay
     */
    public function setDeckDisplay(array $deckDisplay = array())
    {
        // validation for constraint: array
        if ('' !== ($deckDisplayArrayErrorMessage = self::validateDeckDisplayForArrayConstraintsFromSetDeckDisplay($deckDisplay))) {
            throw new \InvalidArgumentException($deckDisplayArrayErrorMessage, __LINE__);
        }
        if (is_null($deckDisplay) || (is_array($deckDisplay) && empty($deckDisplay))) {
            unset($this->DeckDisplay);
        } else {
            $this->DeckDisplay = $deckDisplay;
        }
        return $this;
    }
    /**
     * Add item to DeckDisplay value
     * @throws \InvalidArgumentException
     * @param \StructType\DeckDisplay $item
     * @return \ArrayType\ArrayOfDeckDisplay
     */
    public function addToDeckDisplay(\StructType\DeckDisplay $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\DeckDisplay) {
            throw new \InvalidArgumentException(sprintf('The DeckDisplay property can only contain items of type \StructType\DeckDisplay, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->DeckDisplay[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\DeckDisplay|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\DeckDisplay|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\DeckDisplay|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\DeckDisplay|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\DeckDisplay|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string DeckDisplay
     */
    public function getAttributeName()
    {
        return 'DeckDisplay';
    }
}
