<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfLegdetails ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfLegdetails
 * @subpackage Arrays
 */
class ArrayOfLegdetails extends AbstractStructArrayBase
{
    /**
     * The Legdetails
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\Legdetails[]
     */
    public $Legdetails;
    /**
     * Constructor method for ArrayOfLegdetails
     * @uses ArrayOfLegdetails::setLegdetails()
     * @param \StructType\Legdetails[] $legdetails
     */
    public function __construct(array $legdetails = array())
    {
        $this
            ->setLegdetails($legdetails);
    }
    /**
     * Get Legdetails value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\Legdetails[]|null
     */
    public function getLegdetails()
    {
        return isset($this->Legdetails) ? $this->Legdetails : null;
    }
    /**
     * This method is responsible for validating the values passed to the setLegdetails method
     * This method is willingly generated in order to preserve the one-line inline validation within the setLegdetails method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateLegdetailsForArrayConstraintsFromSetLegdetails(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfLegdetailsLegdetailsItem) {
            // validation for constraint: itemType
            if (!$arrayOfLegdetailsLegdetailsItem instanceof \StructType\Legdetails) {
                $invalidValues[] = is_object($arrayOfLegdetailsLegdetailsItem) ? get_class($arrayOfLegdetailsLegdetailsItem) : sprintf('%s(%s)', gettype($arrayOfLegdetailsLegdetailsItem), var_export($arrayOfLegdetailsLegdetailsItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Legdetails property can only contain items of type \StructType\Legdetails, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Legdetails value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\Legdetails[] $legdetails
     * @return \ArrayType\ArrayOfLegdetails
     */
    public function setLegdetails(array $legdetails = array())
    {
        // validation for constraint: array
        if ('' !== ($legdetailsArrayErrorMessage = self::validateLegdetailsForArrayConstraintsFromSetLegdetails($legdetails))) {
            throw new \InvalidArgumentException($legdetailsArrayErrorMessage, __LINE__);
        }
        if (is_null($legdetails) || (is_array($legdetails) && empty($legdetails))) {
            unset($this->Legdetails);
        } else {
            $this->Legdetails = $legdetails;
        }
        return $this;
    }
    /**
     * Add item to Legdetails value
     * @throws \InvalidArgumentException
     * @param \StructType\Legdetails $item
     * @return \ArrayType\ArrayOfLegdetails
     */
    public function addToLegdetails(\StructType\Legdetails $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Legdetails) {
            throw new \InvalidArgumentException(sprintf('The Legdetails property can only contain items of type \StructType\Legdetails, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Legdetails[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\Legdetails|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\Legdetails|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\Legdetails|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\Legdetails|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\Legdetails|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string Legdetails
     */
    public function getAttributeName()
    {
        return 'Legdetails';
    }
}
