<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfLogicalFlightInfo ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfLogicalFlightInfo
 * @subpackage Arrays
 */
class ArrayOfLogicalFlightInfo extends AbstractStructArrayBase
{
    /**
     * The LogicalFlightInfo
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\LogicalFlightInfo[]
     */
    public $LogicalFlightInfo;
    /**
     * Constructor method for ArrayOfLogicalFlightInfo
     * @uses ArrayOfLogicalFlightInfo::setLogicalFlightInfo()
     * @param \StructType\LogicalFlightInfo[] $logicalFlightInfo
     */
    public function __construct(array $logicalFlightInfo = array())
    {
        $this
            ->setLogicalFlightInfo($logicalFlightInfo);
    }
    /**
     * Get LogicalFlightInfo value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\LogicalFlightInfo[]|null
     */
    public function getLogicalFlightInfo()
    {
        return isset($this->LogicalFlightInfo) ? $this->LogicalFlightInfo : null;
    }
    /**
     * This method is responsible for validating the values passed to the setLogicalFlightInfo method
     * This method is willingly generated in order to preserve the one-line inline validation within the setLogicalFlightInfo method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateLogicalFlightInfoForArrayConstraintsFromSetLogicalFlightInfo(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfLogicalFlightInfoLogicalFlightInfoItem) {
            // validation for constraint: itemType
            if (!$arrayOfLogicalFlightInfoLogicalFlightInfoItem instanceof \StructType\LogicalFlightInfo) {
                $invalidValues[] = is_object($arrayOfLogicalFlightInfoLogicalFlightInfoItem) ? get_class($arrayOfLogicalFlightInfoLogicalFlightInfoItem) : sprintf('%s(%s)', gettype($arrayOfLogicalFlightInfoLogicalFlightInfoItem), var_export($arrayOfLogicalFlightInfoLogicalFlightInfoItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The LogicalFlightInfo property can only contain items of type \StructType\LogicalFlightInfo, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set LogicalFlightInfo value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\LogicalFlightInfo[] $logicalFlightInfo
     * @return \ArrayType\ArrayOfLogicalFlightInfo
     */
    public function setLogicalFlightInfo(array $logicalFlightInfo = array())
    {
        // validation for constraint: array
        if ('' !== ($logicalFlightInfoArrayErrorMessage = self::validateLogicalFlightInfoForArrayConstraintsFromSetLogicalFlightInfo($logicalFlightInfo))) {
            throw new \InvalidArgumentException($logicalFlightInfoArrayErrorMessage, __LINE__);
        }
        if (is_null($logicalFlightInfo) || (is_array($logicalFlightInfo) && empty($logicalFlightInfo))) {
            unset($this->LogicalFlightInfo);
        } else {
            $this->LogicalFlightInfo = $logicalFlightInfo;
        }
        return $this;
    }
    /**
     * Add item to LogicalFlightInfo value
     * @throws \InvalidArgumentException
     * @param \StructType\LogicalFlightInfo $item
     * @return \ArrayType\ArrayOfLogicalFlightInfo
     */
    public function addToLogicalFlightInfo(\StructType\LogicalFlightInfo $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\LogicalFlightInfo) {
            throw new \InvalidArgumentException(sprintf('The LogicalFlightInfo property can only contain items of type \StructType\LogicalFlightInfo, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->LogicalFlightInfo[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\LogicalFlightInfo|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\LogicalFlightInfo|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\LogicalFlightInfo|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\LogicalFlightInfo|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\LogicalFlightInfo|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string LogicalFlightInfo
     */
    public function getAttributeName()
    {
        return 'LogicalFlightInfo';
    }
}
