<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfPhysicalFlightInfo ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfPhysicalFlightInfo
 * @subpackage Arrays
 */
class ArrayOfPhysicalFlightInfo extends AbstractStructArrayBase
{
    /**
     * The PhysicalFlightInfo
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\PhysicalFlightInfo[]
     */
    public $PhysicalFlightInfo;
    /**
     * Constructor method for ArrayOfPhysicalFlightInfo
     * @uses ArrayOfPhysicalFlightInfo::setPhysicalFlightInfo()
     * @param \StructType\PhysicalFlightInfo[] $physicalFlightInfo
     */
    public function __construct(array $physicalFlightInfo = array())
    {
        $this
            ->setPhysicalFlightInfo($physicalFlightInfo);
    }
    /**
     * Get PhysicalFlightInfo value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\PhysicalFlightInfo[]|null
     */
    public function getPhysicalFlightInfo()
    {
        return isset($this->PhysicalFlightInfo) ? $this->PhysicalFlightInfo : null;
    }
    /**
     * This method is responsible for validating the values passed to the setPhysicalFlightInfo method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPhysicalFlightInfo method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePhysicalFlightInfoForArrayConstraintsFromSetPhysicalFlightInfo(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfPhysicalFlightInfoPhysicalFlightInfoItem) {
            // validation for constraint: itemType
            if (!$arrayOfPhysicalFlightInfoPhysicalFlightInfoItem instanceof \StructType\PhysicalFlightInfo) {
                $invalidValues[] = is_object($arrayOfPhysicalFlightInfoPhysicalFlightInfoItem) ? get_class($arrayOfPhysicalFlightInfoPhysicalFlightInfoItem) : sprintf('%s(%s)', gettype($arrayOfPhysicalFlightInfoPhysicalFlightInfoItem), var_export($arrayOfPhysicalFlightInfoPhysicalFlightInfoItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The PhysicalFlightInfo property can only contain items of type \StructType\PhysicalFlightInfo, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set PhysicalFlightInfo value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\PhysicalFlightInfo[] $physicalFlightInfo
     * @return \ArrayType\ArrayOfPhysicalFlightInfo
     */
    public function setPhysicalFlightInfo(array $physicalFlightInfo = array())
    {
        // validation for constraint: array
        if ('' !== ($physicalFlightInfoArrayErrorMessage = self::validatePhysicalFlightInfoForArrayConstraintsFromSetPhysicalFlightInfo($physicalFlightInfo))) {
            throw new \InvalidArgumentException($physicalFlightInfoArrayErrorMessage, __LINE__);
        }
        if (is_null($physicalFlightInfo) || (is_array($physicalFlightInfo) && empty($physicalFlightInfo))) {
            unset($this->PhysicalFlightInfo);
        } else {
            $this->PhysicalFlightInfo = $physicalFlightInfo;
        }
        return $this;
    }
    /**
     * Add item to PhysicalFlightInfo value
     * @throws \InvalidArgumentException
     * @param \StructType\PhysicalFlightInfo $item
     * @return \ArrayType\ArrayOfPhysicalFlightInfo
     */
    public function addToPhysicalFlightInfo(\StructType\PhysicalFlightInfo $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\PhysicalFlightInfo) {
            throw new \InvalidArgumentException(sprintf('The PhysicalFlightInfo property can only contain items of type \StructType\PhysicalFlightInfo, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->PhysicalFlightInfo[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\PhysicalFlightInfo|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\PhysicalFlightInfo|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\PhysicalFlightInfo|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\PhysicalFlightInfo|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\PhysicalFlightInfo|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string PhysicalFlightInfo
     */
    public function getAttributeName()
    {
        return 'PhysicalFlightInfo';
    }
}
