<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfPhysicalFlightMap ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfPhysicalFlightMap
 * @subpackage Arrays
 */
class ArrayOfPhysicalFlightMap extends AbstractStructArrayBase
{
    /**
     * The PhysicalFlightMap
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\PhysicalFlightMap[]
     */
    public $PhysicalFlightMap;
    /**
     * Constructor method for ArrayOfPhysicalFlightMap
     * @uses ArrayOfPhysicalFlightMap::setPhysicalFlightMap()
     * @param \StructType\PhysicalFlightMap[] $physicalFlightMap
     */
    public function __construct(array $physicalFlightMap = array())
    {
        $this
            ->setPhysicalFlightMap($physicalFlightMap);
    }
    /**
     * Get PhysicalFlightMap value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\PhysicalFlightMap[]|null
     */
    public function getPhysicalFlightMap()
    {
        return isset($this->PhysicalFlightMap) ? $this->PhysicalFlightMap : null;
    }
    /**
     * This method is responsible for validating the values passed to the setPhysicalFlightMap method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPhysicalFlightMap method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePhysicalFlightMapForArrayConstraintsFromSetPhysicalFlightMap(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfPhysicalFlightMapPhysicalFlightMapItem) {
            // validation for constraint: itemType
            if (!$arrayOfPhysicalFlightMapPhysicalFlightMapItem instanceof \StructType\PhysicalFlightMap) {
                $invalidValues[] = is_object($arrayOfPhysicalFlightMapPhysicalFlightMapItem) ? get_class($arrayOfPhysicalFlightMapPhysicalFlightMapItem) : sprintf('%s(%s)', gettype($arrayOfPhysicalFlightMapPhysicalFlightMapItem), var_export($arrayOfPhysicalFlightMapPhysicalFlightMapItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The PhysicalFlightMap property can only contain items of type \StructType\PhysicalFlightMap, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set PhysicalFlightMap value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\PhysicalFlightMap[] $physicalFlightMap
     * @return \ArrayType\ArrayOfPhysicalFlightMap
     */
    public function setPhysicalFlightMap(array $physicalFlightMap = array())
    {
        // validation for constraint: array
        if ('' !== ($physicalFlightMapArrayErrorMessage = self::validatePhysicalFlightMapForArrayConstraintsFromSetPhysicalFlightMap($physicalFlightMap))) {
            throw new \InvalidArgumentException($physicalFlightMapArrayErrorMessage, __LINE__);
        }
        if (is_null($physicalFlightMap) || (is_array($physicalFlightMap) && empty($physicalFlightMap))) {
            unset($this->PhysicalFlightMap);
        } else {
            $this->PhysicalFlightMap = $physicalFlightMap;
        }
        return $this;
    }
    /**
     * Add item to PhysicalFlightMap value
     * @throws \InvalidArgumentException
     * @param \StructType\PhysicalFlightMap $item
     * @return \ArrayType\ArrayOfPhysicalFlightMap
     */
    public function addToPhysicalFlightMap(\StructType\PhysicalFlightMap $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\PhysicalFlightMap) {
            throw new \InvalidArgumentException(sprintf('The PhysicalFlightMap property can only contain items of type \StructType\PhysicalFlightMap, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->PhysicalFlightMap[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\PhysicalFlightMap|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\PhysicalFlightMap|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\PhysicalFlightMap|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\PhysicalFlightMap|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\PhysicalFlightMap|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string PhysicalFlightMap
     */
    public function getAttributeName()
    {
        return 'PhysicalFlightMap';
    }
}
