<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfPhysicalTrainMap ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfPhysicalTrainMap
 * @subpackage Arrays
 */
class ArrayOfPhysicalTrainMap extends AbstractStructArrayBase
{
    /**
     * The PhysicalTrainMap
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\PhysicalTrainMap[]
     */
    public $PhysicalTrainMap;
    /**
     * Constructor method for ArrayOfPhysicalTrainMap
     * @uses ArrayOfPhysicalTrainMap::setPhysicalTrainMap()
     * @param \StructType\PhysicalTrainMap[] $physicalTrainMap
     */
    public function __construct(array $physicalTrainMap = array())
    {
        $this
            ->setPhysicalTrainMap($physicalTrainMap);
    }
    /**
     * Get PhysicalTrainMap value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\PhysicalTrainMap[]|null
     */
    public function getPhysicalTrainMap()
    {
        return isset($this->PhysicalTrainMap) ? $this->PhysicalTrainMap : null;
    }
    /**
     * This method is responsible for validating the values passed to the setPhysicalTrainMap method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPhysicalTrainMap method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePhysicalTrainMapForArrayConstraintsFromSetPhysicalTrainMap(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfPhysicalTrainMapPhysicalTrainMapItem) {
            // validation for constraint: itemType
            if (!$arrayOfPhysicalTrainMapPhysicalTrainMapItem instanceof \StructType\PhysicalTrainMap) {
                $invalidValues[] = is_object($arrayOfPhysicalTrainMapPhysicalTrainMapItem) ? get_class($arrayOfPhysicalTrainMapPhysicalTrainMapItem) : sprintf('%s(%s)', gettype($arrayOfPhysicalTrainMapPhysicalTrainMapItem), var_export($arrayOfPhysicalTrainMapPhysicalTrainMapItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The PhysicalTrainMap property can only contain items of type \StructType\PhysicalTrainMap, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set PhysicalTrainMap value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\PhysicalTrainMap[] $physicalTrainMap
     * @return \ArrayType\ArrayOfPhysicalTrainMap
     */
    public function setPhysicalTrainMap(array $physicalTrainMap = array())
    {
        // validation for constraint: array
        if ('' !== ($physicalTrainMapArrayErrorMessage = self::validatePhysicalTrainMapForArrayConstraintsFromSetPhysicalTrainMap($physicalTrainMap))) {
            throw new \InvalidArgumentException($physicalTrainMapArrayErrorMessage, __LINE__);
        }
        if (is_null($physicalTrainMap) || (is_array($physicalTrainMap) && empty($physicalTrainMap))) {
            unset($this->PhysicalTrainMap);
        } else {
            $this->PhysicalTrainMap = $physicalTrainMap;
        }
        return $this;
    }
    /**
     * Add item to PhysicalTrainMap value
     * @throws \InvalidArgumentException
     * @param \StructType\PhysicalTrainMap $item
     * @return \ArrayType\ArrayOfPhysicalTrainMap
     */
    public function addToPhysicalTrainMap(\StructType\PhysicalTrainMap $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\PhysicalTrainMap) {
            throw new \InvalidArgumentException(sprintf('The PhysicalTrainMap property can only contain items of type \StructType\PhysicalTrainMap, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->PhysicalTrainMap[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\PhysicalTrainMap|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\PhysicalTrainMap|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\PhysicalTrainMap|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\PhysicalTrainMap|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\PhysicalTrainMap|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string PhysicalTrainMap
     */
    public function getAttributeName()
    {
        return 'PhysicalTrainMap';
    }
}
