<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfRailCar ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfRailCar
 * @subpackage Arrays
 */
class ArrayOfRailCar extends AbstractStructArrayBase
{
    /**
     * The RailCar
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\RailCar[]
     */
    public $RailCar;
    /**
     * Constructor method for ArrayOfRailCar
     * @uses ArrayOfRailCar::setRailCar()
     * @param \StructType\RailCar[] $railCar
     */
    public function __construct(array $railCar = array())
    {
        $this
            ->setRailCar($railCar);
    }
    /**
     * Get RailCar value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\RailCar[]|null
     */
    public function getRailCar()
    {
        return isset($this->RailCar) ? $this->RailCar : null;
    }
    /**
     * This method is responsible for validating the values passed to the setRailCar method
     * This method is willingly generated in order to preserve the one-line inline validation within the setRailCar method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateRailCarForArrayConstraintsFromSetRailCar(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfRailCarRailCarItem) {
            // validation for constraint: itemType
            if (!$arrayOfRailCarRailCarItem instanceof \StructType\RailCar) {
                $invalidValues[] = is_object($arrayOfRailCarRailCarItem) ? get_class($arrayOfRailCarRailCarItem) : sprintf('%s(%s)', gettype($arrayOfRailCarRailCarItem), var_export($arrayOfRailCarRailCarItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The RailCar property can only contain items of type \StructType\RailCar, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set RailCar value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\RailCar[] $railCar
     * @return \ArrayType\ArrayOfRailCar
     */
    public function setRailCar(array $railCar = array())
    {
        // validation for constraint: array
        if ('' !== ($railCarArrayErrorMessage = self::validateRailCarForArrayConstraintsFromSetRailCar($railCar))) {
            throw new \InvalidArgumentException($railCarArrayErrorMessage, __LINE__);
        }
        if (is_null($railCar) || (is_array($railCar) && empty($railCar))) {
            unset($this->RailCar);
        } else {
            $this->RailCar = $railCar;
        }
        return $this;
    }
    /**
     * Add item to RailCar value
     * @throws \InvalidArgumentException
     * @param \StructType\RailCar $item
     * @return \ArrayType\ArrayOfRailCar
     */
    public function addToRailCar(\StructType\RailCar $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\RailCar) {
            throw new \InvalidArgumentException(sprintf('The RailCar property can only contain items of type \StructType\RailCar, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->RailCar[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\RailCar|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\RailCar|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\RailCar|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\RailCar|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\RailCar|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string RailCar
     */
    public function getAttributeName()
    {
        return 'RailCar';
    }
}
