<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfRestrictionDisplay ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfRestrictionDisplay
 * @subpackage Arrays
 */
class ArrayOfRestrictionDisplay extends AbstractStructArrayBase
{
    /**
     * The RestrictionDisplay
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\RestrictionDisplay[]
     */
    public $RestrictionDisplay;
    /**
     * Constructor method for ArrayOfRestrictionDisplay
     * @uses ArrayOfRestrictionDisplay::setRestrictionDisplay()
     * @param \StructType\RestrictionDisplay[] $restrictionDisplay
     */
    public function __construct(array $restrictionDisplay = array())
    {
        $this
            ->setRestrictionDisplay($restrictionDisplay);
    }
    /**
     * Get RestrictionDisplay value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\RestrictionDisplay[]|null
     */
    public function getRestrictionDisplay()
    {
        return isset($this->RestrictionDisplay) ? $this->RestrictionDisplay : null;
    }
    /**
     * This method is responsible for validating the values passed to the setRestrictionDisplay method
     * This method is willingly generated in order to preserve the one-line inline validation within the setRestrictionDisplay method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateRestrictionDisplayForArrayConstraintsFromSetRestrictionDisplay(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfRestrictionDisplayRestrictionDisplayItem) {
            // validation for constraint: itemType
            if (!$arrayOfRestrictionDisplayRestrictionDisplayItem instanceof \StructType\RestrictionDisplay) {
                $invalidValues[] = is_object($arrayOfRestrictionDisplayRestrictionDisplayItem) ? get_class($arrayOfRestrictionDisplayRestrictionDisplayItem) : sprintf('%s(%s)', gettype($arrayOfRestrictionDisplayRestrictionDisplayItem), var_export($arrayOfRestrictionDisplayRestrictionDisplayItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The RestrictionDisplay property can only contain items of type \StructType\RestrictionDisplay, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set RestrictionDisplay value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\RestrictionDisplay[] $restrictionDisplay
     * @return \ArrayType\ArrayOfRestrictionDisplay
     */
    public function setRestrictionDisplay(array $restrictionDisplay = array())
    {
        // validation for constraint: array
        if ('' !== ($restrictionDisplayArrayErrorMessage = self::validateRestrictionDisplayForArrayConstraintsFromSetRestrictionDisplay($restrictionDisplay))) {
            throw new \InvalidArgumentException($restrictionDisplayArrayErrorMessage, __LINE__);
        }
        if (is_null($restrictionDisplay) || (is_array($restrictionDisplay) && empty($restrictionDisplay))) {
            unset($this->RestrictionDisplay);
        } else {
            $this->RestrictionDisplay = $restrictionDisplay;
        }
        return $this;
    }
    /**
     * Add item to RestrictionDisplay value
     * @throws \InvalidArgumentException
     * @param \StructType\RestrictionDisplay $item
     * @return \ArrayType\ArrayOfRestrictionDisplay
     */
    public function addToRestrictionDisplay(\StructType\RestrictionDisplay $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\RestrictionDisplay) {
            throw new \InvalidArgumentException(sprintf('The RestrictionDisplay property can only contain items of type \StructType\RestrictionDisplay, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->RestrictionDisplay[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\RestrictionDisplay|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\RestrictionDisplay|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\RestrictionDisplay|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\RestrictionDisplay|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\RestrictionDisplay|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string RestrictionDisplay
     */
    public function getAttributeName()
    {
        return 'RestrictionDisplay';
    }
}
