<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfRowDisplay ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfRowDisplay
 * @subpackage Arrays
 */
class ArrayOfRowDisplay extends AbstractStructArrayBase
{
    /**
     * The RowDisplay
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\RowDisplay[]
     */
    public $RowDisplay;
    /**
     * Constructor method for ArrayOfRowDisplay
     * @uses ArrayOfRowDisplay::setRowDisplay()
     * @param \StructType\RowDisplay[] $rowDisplay
     */
    public function __construct(array $rowDisplay = array())
    {
        $this
            ->setRowDisplay($rowDisplay);
    }
    /**
     * Get RowDisplay value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\RowDisplay[]|null
     */
    public function getRowDisplay()
    {
        return isset($this->RowDisplay) ? $this->RowDisplay : null;
    }
    /**
     * This method is responsible for validating the values passed to the setRowDisplay method
     * This method is willingly generated in order to preserve the one-line inline validation within the setRowDisplay method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateRowDisplayForArrayConstraintsFromSetRowDisplay(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfRowDisplayRowDisplayItem) {
            // validation for constraint: itemType
            if (!$arrayOfRowDisplayRowDisplayItem instanceof \StructType\RowDisplay) {
                $invalidValues[] = is_object($arrayOfRowDisplayRowDisplayItem) ? get_class($arrayOfRowDisplayRowDisplayItem) : sprintf('%s(%s)', gettype($arrayOfRowDisplayRowDisplayItem), var_export($arrayOfRowDisplayRowDisplayItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The RowDisplay property can only contain items of type \StructType\RowDisplay, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set RowDisplay value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\RowDisplay[] $rowDisplay
     * @return \ArrayType\ArrayOfRowDisplay
     */
    public function setRowDisplay(array $rowDisplay = array())
    {
        // validation for constraint: array
        if ('' !== ($rowDisplayArrayErrorMessage = self::validateRowDisplayForArrayConstraintsFromSetRowDisplay($rowDisplay))) {
            throw new \InvalidArgumentException($rowDisplayArrayErrorMessage, __LINE__);
        }
        if (is_null($rowDisplay) || (is_array($rowDisplay) && empty($rowDisplay))) {
            unset($this->RowDisplay);
        } else {
            $this->RowDisplay = $rowDisplay;
        }
        return $this;
    }
    /**
     * Add item to RowDisplay value
     * @throws \InvalidArgumentException
     * @param \StructType\RowDisplay $item
     * @return \ArrayType\ArrayOfRowDisplay
     */
    public function addToRowDisplay(\StructType\RowDisplay $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\RowDisplay) {
            throw new \InvalidArgumentException(sprintf('The RowDisplay property can only contain items of type \StructType\RowDisplay, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->RowDisplay[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\RowDisplay|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\RowDisplay|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\RowDisplay|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\RowDisplay|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\RowDisplay|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string RowDisplay
     */
    public function getAttributeName()
    {
        return 'RowDisplay';
    }
}
