<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfSeatAttributeDisplay ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfSeatAttributeDisplay
 * @subpackage Arrays
 */
class ArrayOfSeatAttributeDisplay extends AbstractStructArrayBase
{
    /**
     * The SeatAttributeDisplay
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\SeatAttributeDisplay[]
     */
    public $SeatAttributeDisplay;
    /**
     * Constructor method for ArrayOfSeatAttributeDisplay
     * @uses ArrayOfSeatAttributeDisplay::setSeatAttributeDisplay()
     * @param \StructType\SeatAttributeDisplay[] $seatAttributeDisplay
     */
    public function __construct(array $seatAttributeDisplay = array())
    {
        $this
            ->setSeatAttributeDisplay($seatAttributeDisplay);
    }
    /**
     * Get SeatAttributeDisplay value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\SeatAttributeDisplay[]|null
     */
    public function getSeatAttributeDisplay()
    {
        return isset($this->SeatAttributeDisplay) ? $this->SeatAttributeDisplay : null;
    }
    /**
     * This method is responsible for validating the values passed to the setSeatAttributeDisplay method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSeatAttributeDisplay method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSeatAttributeDisplayForArrayConstraintsFromSetSeatAttributeDisplay(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfSeatAttributeDisplaySeatAttributeDisplayItem) {
            // validation for constraint: itemType
            if (!$arrayOfSeatAttributeDisplaySeatAttributeDisplayItem instanceof \StructType\SeatAttributeDisplay) {
                $invalidValues[] = is_object($arrayOfSeatAttributeDisplaySeatAttributeDisplayItem) ? get_class($arrayOfSeatAttributeDisplaySeatAttributeDisplayItem) : sprintf('%s(%s)', gettype($arrayOfSeatAttributeDisplaySeatAttributeDisplayItem), var_export($arrayOfSeatAttributeDisplaySeatAttributeDisplayItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The SeatAttributeDisplay property can only contain items of type \StructType\SeatAttributeDisplay, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set SeatAttributeDisplay value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\SeatAttributeDisplay[] $seatAttributeDisplay
     * @return \ArrayType\ArrayOfSeatAttributeDisplay
     */
    public function setSeatAttributeDisplay(array $seatAttributeDisplay = array())
    {
        // validation for constraint: array
        if ('' !== ($seatAttributeDisplayArrayErrorMessage = self::validateSeatAttributeDisplayForArrayConstraintsFromSetSeatAttributeDisplay($seatAttributeDisplay))) {
            throw new \InvalidArgumentException($seatAttributeDisplayArrayErrorMessage, __LINE__);
        }
        if (is_null($seatAttributeDisplay) || (is_array($seatAttributeDisplay) && empty($seatAttributeDisplay))) {
            unset($this->SeatAttributeDisplay);
        } else {
            $this->SeatAttributeDisplay = $seatAttributeDisplay;
        }
        return $this;
    }
    /**
     * Add item to SeatAttributeDisplay value
     * @throws \InvalidArgumentException
     * @param \StructType\SeatAttributeDisplay $item
     * @return \ArrayType\ArrayOfSeatAttributeDisplay
     */
    public function addToSeatAttributeDisplay(\StructType\SeatAttributeDisplay $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\SeatAttributeDisplay) {
            throw new \InvalidArgumentException(sprintf('The SeatAttributeDisplay property can only contain items of type \StructType\SeatAttributeDisplay, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->SeatAttributeDisplay[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\SeatAttributeDisplay|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\SeatAttributeDisplay|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\SeatAttributeDisplay|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\SeatAttributeDisplay|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\SeatAttributeDisplay|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string SeatAttributeDisplay
     */
    public function getAttributeName()
    {
        return 'SeatAttributeDisplay';
    }
}
