<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfSeatCabinDisplay ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfSeatCabinDisplay
 * @subpackage Arrays
 */
class ArrayOfSeatCabinDisplay extends AbstractStructArrayBase
{
    /**
     * The SeatCabinDisplay
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\SeatCabinDisplay[]
     */
    public $SeatCabinDisplay;
    /**
     * Constructor method for ArrayOfSeatCabinDisplay
     * @uses ArrayOfSeatCabinDisplay::setSeatCabinDisplay()
     * @param \StructType\SeatCabinDisplay[] $seatCabinDisplay
     */
    public function __construct(array $seatCabinDisplay = array())
    {
        $this
            ->setSeatCabinDisplay($seatCabinDisplay);
    }
    /**
     * Get SeatCabinDisplay value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\SeatCabinDisplay[]|null
     */
    public function getSeatCabinDisplay()
    {
        return isset($this->SeatCabinDisplay) ? $this->SeatCabinDisplay : null;
    }
    /**
     * This method is responsible for validating the values passed to the setSeatCabinDisplay method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSeatCabinDisplay method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSeatCabinDisplayForArrayConstraintsFromSetSeatCabinDisplay(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfSeatCabinDisplaySeatCabinDisplayItem) {
            // validation for constraint: itemType
            if (!$arrayOfSeatCabinDisplaySeatCabinDisplayItem instanceof \StructType\SeatCabinDisplay) {
                $invalidValues[] = is_object($arrayOfSeatCabinDisplaySeatCabinDisplayItem) ? get_class($arrayOfSeatCabinDisplaySeatCabinDisplayItem) : sprintf('%s(%s)', gettype($arrayOfSeatCabinDisplaySeatCabinDisplayItem), var_export($arrayOfSeatCabinDisplaySeatCabinDisplayItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The SeatCabinDisplay property can only contain items of type \StructType\SeatCabinDisplay, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set SeatCabinDisplay value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\SeatCabinDisplay[] $seatCabinDisplay
     * @return \ArrayType\ArrayOfSeatCabinDisplay
     */
    public function setSeatCabinDisplay(array $seatCabinDisplay = array())
    {
        // validation for constraint: array
        if ('' !== ($seatCabinDisplayArrayErrorMessage = self::validateSeatCabinDisplayForArrayConstraintsFromSetSeatCabinDisplay($seatCabinDisplay))) {
            throw new \InvalidArgumentException($seatCabinDisplayArrayErrorMessage, __LINE__);
        }
        if (is_null($seatCabinDisplay) || (is_array($seatCabinDisplay) && empty($seatCabinDisplay))) {
            unset($this->SeatCabinDisplay);
        } else {
            $this->SeatCabinDisplay = $seatCabinDisplay;
        }
        return $this;
    }
    /**
     * Add item to SeatCabinDisplay value
     * @throws \InvalidArgumentException
     * @param \StructType\SeatCabinDisplay $item
     * @return \ArrayType\ArrayOfSeatCabinDisplay
     */
    public function addToSeatCabinDisplay(\StructType\SeatCabinDisplay $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\SeatCabinDisplay) {
            throw new \InvalidArgumentException(sprintf('The SeatCabinDisplay property can only contain items of type \StructType\SeatCabinDisplay, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->SeatCabinDisplay[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\SeatCabinDisplay|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\SeatCabinDisplay|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\SeatCabinDisplay|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\SeatCabinDisplay|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\SeatCabinDisplay|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string SeatCabinDisplay
     */
    public function getAttributeName()
    {
        return 'SeatCabinDisplay';
    }
}
