<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfSeatCharge ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfSeatCharge
 * @subpackage Arrays
 */
class ArrayOfSeatCharge extends AbstractStructArrayBase
{
    /**
     * The SeatCharge
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\SeatCharge[]
     */
    public $SeatCharge;
    /**
     * Constructor method for ArrayOfSeatCharge
     * @uses ArrayOfSeatCharge::setSeatCharge()
     * @param \StructType\SeatCharge[] $seatCharge
     */
    public function __construct(array $seatCharge = array())
    {
        $this
            ->setSeatCharge($seatCharge);
    }
    /**
     * Get SeatCharge value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\SeatCharge[]|null
     */
    public function getSeatCharge()
    {
        return isset($this->SeatCharge) ? $this->SeatCharge : null;
    }
    /**
     * This method is responsible for validating the values passed to the setSeatCharge method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSeatCharge method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSeatChargeForArrayConstraintsFromSetSeatCharge(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfSeatChargeSeatChargeItem) {
            // validation for constraint: itemType
            if (!$arrayOfSeatChargeSeatChargeItem instanceof \StructType\SeatCharge) {
                $invalidValues[] = is_object($arrayOfSeatChargeSeatChargeItem) ? get_class($arrayOfSeatChargeSeatChargeItem) : sprintf('%s(%s)', gettype($arrayOfSeatChargeSeatChargeItem), var_export($arrayOfSeatChargeSeatChargeItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The SeatCharge property can only contain items of type \StructType\SeatCharge, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set SeatCharge value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\SeatCharge[] $seatCharge
     * @return \ArrayType\ArrayOfSeatCharge
     */
    public function setSeatCharge(array $seatCharge = array())
    {
        // validation for constraint: array
        if ('' !== ($seatChargeArrayErrorMessage = self::validateSeatChargeForArrayConstraintsFromSetSeatCharge($seatCharge))) {
            throw new \InvalidArgumentException($seatChargeArrayErrorMessage, __LINE__);
        }
        if (is_null($seatCharge) || (is_array($seatCharge) && empty($seatCharge))) {
            unset($this->SeatCharge);
        } else {
            $this->SeatCharge = $seatCharge;
        }
        return $this;
    }
    /**
     * Add item to SeatCharge value
     * @throws \InvalidArgumentException
     * @param \StructType\SeatCharge $item
     * @return \ArrayType\ArrayOfSeatCharge
     */
    public function addToSeatCharge(\StructType\SeatCharge $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\SeatCharge) {
            throw new \InvalidArgumentException(sprintf('The SeatCharge property can only contain items of type \StructType\SeatCharge, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->SeatCharge[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\SeatCharge|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\SeatCharge|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\SeatCharge|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\SeatCharge|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\SeatCharge|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string SeatCharge
     */
    public function getAttributeName()
    {
        return 'SeatCharge';
    }
}
