<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfSeatCode ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfSeatCode
 * @subpackage Arrays
 */
class ArrayOfSeatCode extends AbstractStructArrayBase
{
    /**
     * The SeatCode
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\SeatCode[]
     */
    public $SeatCode;
    /**
     * Constructor method for ArrayOfSeatCode
     * @uses ArrayOfSeatCode::setSeatCode()
     * @param \StructType\SeatCode[] $seatCode
     */
    public function __construct(array $seatCode = array())
    {
        $this
            ->setSeatCode($seatCode);
    }
    /**
     * Get SeatCode value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\SeatCode[]|null
     */
    public function getSeatCode()
    {
        return isset($this->SeatCode) ? $this->SeatCode : null;
    }
    /**
     * This method is responsible for validating the values passed to the setSeatCode method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSeatCode method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSeatCodeForArrayConstraintsFromSetSeatCode(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfSeatCodeSeatCodeItem) {
            // validation for constraint: itemType
            if (!$arrayOfSeatCodeSeatCodeItem instanceof \StructType\SeatCode) {
                $invalidValues[] = is_object($arrayOfSeatCodeSeatCodeItem) ? get_class($arrayOfSeatCodeSeatCodeItem) : sprintf('%s(%s)', gettype($arrayOfSeatCodeSeatCodeItem), var_export($arrayOfSeatCodeSeatCodeItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The SeatCode property can only contain items of type \StructType\SeatCode, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set SeatCode value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\SeatCode[] $seatCode
     * @return \ArrayType\ArrayOfSeatCode
     */
    public function setSeatCode(array $seatCode = array())
    {
        // validation for constraint: array
        if ('' !== ($seatCodeArrayErrorMessage = self::validateSeatCodeForArrayConstraintsFromSetSeatCode($seatCode))) {
            throw new \InvalidArgumentException($seatCodeArrayErrorMessage, __LINE__);
        }
        if (is_null($seatCode) || (is_array($seatCode) && empty($seatCode))) {
            unset($this->SeatCode);
        } else {
            $this->SeatCode = $seatCode;
        }
        return $this;
    }
    /**
     * Add item to SeatCode value
     * @throws \InvalidArgumentException
     * @param \StructType\SeatCode $item
     * @return \ArrayType\ArrayOfSeatCode
     */
    public function addToSeatCode(\StructType\SeatCode $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\SeatCode) {
            throw new \InvalidArgumentException(sprintf('The SeatCode property can only contain items of type \StructType\SeatCode, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->SeatCode[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\SeatCode|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\SeatCode|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\SeatCode|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\SeatCode|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\SeatCode|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string SeatCode
     */
    public function getAttributeName()
    {
        return 'SeatCode';
    }
}
