<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfSeatDisplay ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfSeatDisplay
 * @subpackage Arrays
 */
class ArrayOfSeatDisplay extends AbstractStructArrayBase
{
    /**
     * The SeatDisplay
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\SeatDisplay[]
     */
    public $SeatDisplay;
    /**
     * Constructor method for ArrayOfSeatDisplay
     * @uses ArrayOfSeatDisplay::setSeatDisplay()
     * @param \StructType\SeatDisplay[] $seatDisplay
     */
    public function __construct(array $seatDisplay = array())
    {
        $this
            ->setSeatDisplay($seatDisplay);
    }
    /**
     * Get SeatDisplay value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\SeatDisplay[]|null
     */
    public function getSeatDisplay()
    {
        return isset($this->SeatDisplay) ? $this->SeatDisplay : null;
    }
    /**
     * This method is responsible for validating the values passed to the setSeatDisplay method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSeatDisplay method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSeatDisplayForArrayConstraintsFromSetSeatDisplay(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfSeatDisplaySeatDisplayItem) {
            // validation for constraint: itemType
            if (!$arrayOfSeatDisplaySeatDisplayItem instanceof \StructType\SeatDisplay) {
                $invalidValues[] = is_object($arrayOfSeatDisplaySeatDisplayItem) ? get_class($arrayOfSeatDisplaySeatDisplayItem) : sprintf('%s(%s)', gettype($arrayOfSeatDisplaySeatDisplayItem), var_export($arrayOfSeatDisplaySeatDisplayItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The SeatDisplay property can only contain items of type \StructType\SeatDisplay, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set SeatDisplay value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\SeatDisplay[] $seatDisplay
     * @return \ArrayType\ArrayOfSeatDisplay
     */
    public function setSeatDisplay(array $seatDisplay = array())
    {
        // validation for constraint: array
        if ('' !== ($seatDisplayArrayErrorMessage = self::validateSeatDisplayForArrayConstraintsFromSetSeatDisplay($seatDisplay))) {
            throw new \InvalidArgumentException($seatDisplayArrayErrorMessage, __LINE__);
        }
        if (is_null($seatDisplay) || (is_array($seatDisplay) && empty($seatDisplay))) {
            unset($this->SeatDisplay);
        } else {
            $this->SeatDisplay = $seatDisplay;
        }
        return $this;
    }
    /**
     * Add item to SeatDisplay value
     * @throws \InvalidArgumentException
     * @param \StructType\SeatDisplay $item
     * @return \ArrayType\ArrayOfSeatDisplay
     */
    public function addToSeatDisplay(\StructType\SeatDisplay $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\SeatDisplay) {
            throw new \InvalidArgumentException(sprintf('The SeatDisplay property can only contain items of type \StructType\SeatDisplay, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->SeatDisplay[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\SeatDisplay|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\SeatDisplay|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\SeatDisplay|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\SeatDisplay|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\SeatDisplay|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string SeatDisplay
     */
    public function getAttributeName()
    {
        return 'SeatDisplay';
    }
}
