<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfSeatException ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfSeatException
 * @subpackage Arrays
 */
class ArrayOfSeatException extends AbstractStructArrayBase
{
    /**
     * The SeatException
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\SeatException[]
     */
    public $SeatException;
    /**
     * Constructor method for ArrayOfSeatException
     * @uses ArrayOfSeatException::setSeatException()
     * @param \StructType\SeatException[] $seatException
     */
    public function __construct(array $seatException = array())
    {
        $this
            ->setSeatException($seatException);
    }
    /**
     * Get SeatException value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\SeatException[]|null
     */
    public function getSeatException()
    {
        return isset($this->SeatException) ? $this->SeatException : null;
    }
    /**
     * This method is responsible for validating the values passed to the setSeatException method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSeatException method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSeatExceptionForArrayConstraintsFromSetSeatException(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfSeatExceptionSeatExceptionItem) {
            // validation for constraint: itemType
            if (!$arrayOfSeatExceptionSeatExceptionItem instanceof \StructType\SeatException) {
                $invalidValues[] = is_object($arrayOfSeatExceptionSeatExceptionItem) ? get_class($arrayOfSeatExceptionSeatExceptionItem) : sprintf('%s(%s)', gettype($arrayOfSeatExceptionSeatExceptionItem), var_export($arrayOfSeatExceptionSeatExceptionItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The SeatException property can only contain items of type \StructType\SeatException, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set SeatException value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\SeatException[] $seatException
     * @return \ArrayType\ArrayOfSeatException
     */
    public function setSeatException(array $seatException = array())
    {
        // validation for constraint: array
        if ('' !== ($seatExceptionArrayErrorMessage = self::validateSeatExceptionForArrayConstraintsFromSetSeatException($seatException))) {
            throw new \InvalidArgumentException($seatExceptionArrayErrorMessage, __LINE__);
        }
        if (is_null($seatException) || (is_array($seatException) && empty($seatException))) {
            unset($this->SeatException);
        } else {
            $this->SeatException = $seatException;
        }
        return $this;
    }
    /**
     * Add item to SeatException value
     * @throws \InvalidArgumentException
     * @param \StructType\SeatException $item
     * @return \ArrayType\ArrayOfSeatException
     */
    public function addToSeatException(\StructType\SeatException $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\SeatException) {
            throw new \InvalidArgumentException(sprintf('The SeatException property can only contain items of type \StructType\SeatException, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->SeatException[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\SeatException|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\SeatException|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\SeatException|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\SeatException|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\SeatException|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string SeatException
     */
    public function getAttributeName()
    {
        return 'SeatException';
    }
}
