<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfSeatPriceOffer ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfSeatPriceOffer
 * @subpackage Arrays
 */
class ArrayOfSeatPriceOffer extends AbstractStructArrayBase
{
    /**
     * The SeatPriceOffer
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\SeatPriceOffer[]
     */
    public $SeatPriceOffer;
    /**
     * Constructor method for ArrayOfSeatPriceOffer
     * @uses ArrayOfSeatPriceOffer::setSeatPriceOffer()
     * @param \StructType\SeatPriceOffer[] $seatPriceOffer
     */
    public function __construct(array $seatPriceOffer = array())
    {
        $this
            ->setSeatPriceOffer($seatPriceOffer);
    }
    /**
     * Get SeatPriceOffer value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\SeatPriceOffer[]|null
     */
    public function getSeatPriceOffer()
    {
        return isset($this->SeatPriceOffer) ? $this->SeatPriceOffer : null;
    }
    /**
     * This method is responsible for validating the values passed to the setSeatPriceOffer method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSeatPriceOffer method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSeatPriceOfferForArrayConstraintsFromSetSeatPriceOffer(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfSeatPriceOfferSeatPriceOfferItem) {
            // validation for constraint: itemType
            if (!$arrayOfSeatPriceOfferSeatPriceOfferItem instanceof \StructType\SeatPriceOffer) {
                $invalidValues[] = is_object($arrayOfSeatPriceOfferSeatPriceOfferItem) ? get_class($arrayOfSeatPriceOfferSeatPriceOfferItem) : sprintf('%s(%s)', gettype($arrayOfSeatPriceOfferSeatPriceOfferItem), var_export($arrayOfSeatPriceOfferSeatPriceOfferItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The SeatPriceOffer property can only contain items of type \StructType\SeatPriceOffer, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set SeatPriceOffer value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\SeatPriceOffer[] $seatPriceOffer
     * @return \ArrayType\ArrayOfSeatPriceOffer
     */
    public function setSeatPriceOffer(array $seatPriceOffer = array())
    {
        // validation for constraint: array
        if ('' !== ($seatPriceOfferArrayErrorMessage = self::validateSeatPriceOfferForArrayConstraintsFromSetSeatPriceOffer($seatPriceOffer))) {
            throw new \InvalidArgumentException($seatPriceOfferArrayErrorMessage, __LINE__);
        }
        if (is_null($seatPriceOffer) || (is_array($seatPriceOffer) && empty($seatPriceOffer))) {
            unset($this->SeatPriceOffer);
        } else {
            $this->SeatPriceOffer = $seatPriceOffer;
        }
        return $this;
    }
    /**
     * Add item to SeatPriceOffer value
     * @throws \InvalidArgumentException
     * @param \StructType\SeatPriceOffer $item
     * @return \ArrayType\ArrayOfSeatPriceOffer
     */
    public function addToSeatPriceOffer(\StructType\SeatPriceOffer $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\SeatPriceOffer) {
            throw new \InvalidArgumentException(sprintf('The SeatPriceOffer property can only contain items of type \StructType\SeatPriceOffer, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->SeatPriceOffer[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\SeatPriceOffer|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\SeatPriceOffer|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\SeatPriceOffer|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\SeatPriceOffer|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\SeatPriceOffer|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string SeatPriceOffer
     */
    public function getAttributeName()
    {
        return 'SeatPriceOffer';
    }
}
