<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfSeatWBZoneDisplay ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfSeatWBZoneDisplay
 * @subpackage Arrays
 */
class ArrayOfSeatWBZoneDisplay extends AbstractStructArrayBase
{
    /**
     * The SeatWBZoneDisplay
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\SeatWBZoneDisplay[]
     */
    public $SeatWBZoneDisplay;
    /**
     * Constructor method for ArrayOfSeatWBZoneDisplay
     * @uses ArrayOfSeatWBZoneDisplay::setSeatWBZoneDisplay()
     * @param \StructType\SeatWBZoneDisplay[] $seatWBZoneDisplay
     */
    public function __construct(array $seatWBZoneDisplay = array())
    {
        $this
            ->setSeatWBZoneDisplay($seatWBZoneDisplay);
    }
    /**
     * Get SeatWBZoneDisplay value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\SeatWBZoneDisplay[]|null
     */
    public function getSeatWBZoneDisplay()
    {
        return isset($this->SeatWBZoneDisplay) ? $this->SeatWBZoneDisplay : null;
    }
    /**
     * This method is responsible for validating the values passed to the setSeatWBZoneDisplay method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSeatWBZoneDisplay method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSeatWBZoneDisplayForArrayConstraintsFromSetSeatWBZoneDisplay(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfSeatWBZoneDisplaySeatWBZoneDisplayItem) {
            // validation for constraint: itemType
            if (!$arrayOfSeatWBZoneDisplaySeatWBZoneDisplayItem instanceof \StructType\SeatWBZoneDisplay) {
                $invalidValues[] = is_object($arrayOfSeatWBZoneDisplaySeatWBZoneDisplayItem) ? get_class($arrayOfSeatWBZoneDisplaySeatWBZoneDisplayItem) : sprintf('%s(%s)', gettype($arrayOfSeatWBZoneDisplaySeatWBZoneDisplayItem), var_export($arrayOfSeatWBZoneDisplaySeatWBZoneDisplayItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The SeatWBZoneDisplay property can only contain items of type \StructType\SeatWBZoneDisplay, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set SeatWBZoneDisplay value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\SeatWBZoneDisplay[] $seatWBZoneDisplay
     * @return \ArrayType\ArrayOfSeatWBZoneDisplay
     */
    public function setSeatWBZoneDisplay(array $seatWBZoneDisplay = array())
    {
        // validation for constraint: array
        if ('' !== ($seatWBZoneDisplayArrayErrorMessage = self::validateSeatWBZoneDisplayForArrayConstraintsFromSetSeatWBZoneDisplay($seatWBZoneDisplay))) {
            throw new \InvalidArgumentException($seatWBZoneDisplayArrayErrorMessage, __LINE__);
        }
        if (is_null($seatWBZoneDisplay) || (is_array($seatWBZoneDisplay) && empty($seatWBZoneDisplay))) {
            unset($this->SeatWBZoneDisplay);
        } else {
            $this->SeatWBZoneDisplay = $seatWBZoneDisplay;
        }
        return $this;
    }
    /**
     * Add item to SeatWBZoneDisplay value
     * @throws \InvalidArgumentException
     * @param \StructType\SeatWBZoneDisplay $item
     * @return \ArrayType\ArrayOfSeatWBZoneDisplay
     */
    public function addToSeatWBZoneDisplay(\StructType\SeatWBZoneDisplay $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\SeatWBZoneDisplay) {
            throw new \InvalidArgumentException(sprintf('The SeatWBZoneDisplay property can only contain items of type \StructType\SeatWBZoneDisplay, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->SeatWBZoneDisplay[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\SeatWBZoneDisplay|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\SeatWBZoneDisplay|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\SeatWBZoneDisplay|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\SeatWBZoneDisplay|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\SeatWBZoneDisplay|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string SeatWBZoneDisplay
     */
    public function getAttributeName()
    {
        return 'SeatWBZoneDisplay';
    }
}
