<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfViewUpdateLidAircraft ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfViewUpdateLidAircraft
 * @subpackage Arrays
 */
class ArrayOfViewUpdateLidAircraft extends AbstractStructArrayBase
{
    /**
     * The ViewUpdateLidAircraft
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ViewUpdateLidAircraft[]
     */
    public $ViewUpdateLidAircraft;
    /**
     * Constructor method for ArrayOfViewUpdateLidAircraft
     * @uses ArrayOfViewUpdateLidAircraft::setViewUpdateLidAircraft()
     * @param \StructType\ViewUpdateLidAircraft[] $viewUpdateLidAircraft
     */
    public function __construct(array $viewUpdateLidAircraft = array())
    {
        $this
            ->setViewUpdateLidAircraft($viewUpdateLidAircraft);
    }
    /**
     * Get ViewUpdateLidAircraft value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ViewUpdateLidAircraft[]|null
     */
    public function getViewUpdateLidAircraft()
    {
        return isset($this->ViewUpdateLidAircraft) ? $this->ViewUpdateLidAircraft : null;
    }
    /**
     * This method is responsible for validating the values passed to the setViewUpdateLidAircraft method
     * This method is willingly generated in order to preserve the one-line inline validation within the setViewUpdateLidAircraft method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateViewUpdateLidAircraftForArrayConstraintsFromSetViewUpdateLidAircraft(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfViewUpdateLidAircraftViewUpdateLidAircraftItem) {
            // validation for constraint: itemType
            if (!$arrayOfViewUpdateLidAircraftViewUpdateLidAircraftItem instanceof \StructType\ViewUpdateLidAircraft) {
                $invalidValues[] = is_object($arrayOfViewUpdateLidAircraftViewUpdateLidAircraftItem) ? get_class($arrayOfViewUpdateLidAircraftViewUpdateLidAircraftItem) : sprintf('%s(%s)', gettype($arrayOfViewUpdateLidAircraftViewUpdateLidAircraftItem), var_export($arrayOfViewUpdateLidAircraftViewUpdateLidAircraftItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ViewUpdateLidAircraft property can only contain items of type \StructType\ViewUpdateLidAircraft, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ViewUpdateLidAircraft value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ViewUpdateLidAircraft[] $viewUpdateLidAircraft
     * @return \ArrayType\ArrayOfViewUpdateLidAircraft
     */
    public function setViewUpdateLidAircraft(array $viewUpdateLidAircraft = array())
    {
        // validation for constraint: array
        if ('' !== ($viewUpdateLidAircraftArrayErrorMessage = self::validateViewUpdateLidAircraftForArrayConstraintsFromSetViewUpdateLidAircraft($viewUpdateLidAircraft))) {
            throw new \InvalidArgumentException($viewUpdateLidAircraftArrayErrorMessage, __LINE__);
        }
        if (is_null($viewUpdateLidAircraft) || (is_array($viewUpdateLidAircraft) && empty($viewUpdateLidAircraft))) {
            unset($this->ViewUpdateLidAircraft);
        } else {
            $this->ViewUpdateLidAircraft = $viewUpdateLidAircraft;
        }
        return $this;
    }
    /**
     * Add item to ViewUpdateLidAircraft value
     * @throws \InvalidArgumentException
     * @param \StructType\ViewUpdateLidAircraft $item
     * @return \ArrayType\ArrayOfViewUpdateLidAircraft
     */
    public function addToViewUpdateLidAircraft(\StructType\ViewUpdateLidAircraft $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ViewUpdateLidAircraft) {
            throw new \InvalidArgumentException(sprintf('The ViewUpdateLidAircraft property can only contain items of type \StructType\ViewUpdateLidAircraft, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ViewUpdateLidAircraft[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ViewUpdateLidAircraft|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ViewUpdateLidAircraft|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ViewUpdateLidAircraft|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ViewUpdateLidAircraft|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ViewUpdateLidAircraft|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ViewUpdateLidAircraft
     */
    public function getAttributeName()
    {
        return 'ViewUpdateLidAircraft';
    }
}
