<?php
/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'RetrieveSeatAvailabilityList' => '\\StructType\\RetrieveSeatAvailabilityList',
            'RetrieveSeatAvailabilityListResponse' => '\\StructType\\RetrieveSeatAvailabilityListResponse',
            'RetrieveAirportRoutes' => '\\StructType\\RetrieveAirportRoutes',
            'RetrieveAirportRoutesResponse' => '\\StructType\\RetrieveAirportRoutesResponse',
            'UpdateLidAircraft' => '\\StructType\\UpdateLidAircraft',
            'UpdateLidAircraftResponse' => '\\StructType\\UpdateLidAircraftResponse',
            'GetFlightScheduleInformation' => '\\StructType\\GetFlightScheduleInformation',
            'GetFlightScheduleInformationResponse' => '\\StructType\\GetFlightScheduleInformationResponse',
            'RetrieveAllConfirmations' => '\\StructType\\RetrieveAllConfirmations',
            'RetrieveAllConfirmationsResponse' => '\\StructType\\RetrieveAllConfirmationsResponse',
            'RetrieveFlightStatus_V1' => '\\StructType\\RetrieveFlightStatus_V1',
            'RetrieveFlightStatus_V1Response' => '\\StructType\\RetrieveFlightStatus_V1Response',
            'RetrieveSeatAvailabilityShop' => '\\StructType\\RetrieveSeatAvailabilityShop',
            'RetrieveSeatAvailabilityShopResponse' => '\\StructType\\RetrieveSeatAvailabilityShopResponse',
            'RetrieveLogicalFlightInfo' => '\\StructType\\RetrieveLogicalFlightInfo',
            'RetrieveLogicalFlightInfoResponse' => '\\StructType\\RetrieveLogicalFlightInfoResponse',
            'RetrieveFlightSeatMap' => '\\StructType\\RetrieveFlightSeatMap',
            'RetrieveFlightSeatMapResponse' => '\\StructType\\RetrieveFlightSeatMapResponse',
            'RetrieveTrainSeatMap' => '\\StructType\\RetrieveTrainSeatMap',
            'RetrieveTrainSeatMapResponse' => '\\StructType\\RetrieveTrainSeatMapResponse',
            'RetrieveAllTrainSeatMap' => '\\StructType\\RetrieveAllTrainSeatMap',
            'RetrieveAllTrainSeatMapResponse' => '\\StructType\\RetrieveAllTrainSeatMapResponse',
            'UpdateInventoryAirCraftLid' => '\\StructType\\UpdateInventoryAirCraftLid',
            'FlightDetails' => '\\StructType\\FlightDetails',
            'BookDateSearch' => '\\StructType\\BookDateSearch',
            'RetrieveFlightStatus' => '\\StructType\\RetrieveFlightStatus',
            'TransactionInfo' => '\\StructType\\TransactionInfo',
            'ArrayOfCarrierCode' => '\\ArrayType\\ArrayOfCarrierCode',
            'CarrierCode' => '\\StructType\\CarrierCode',
            'TransactionInfoNoSession' => '\\StructType\\TransactionInfoNoSession',
            'ViewSeatAvailability' => '\\StructType\\ViewSeatAvailability',
            'ArrayOfPhysicalFlight' => '\\ArrayType\\ArrayOfPhysicalFlight',
            'PhysicalFlight' => '\\StructType\\PhysicalFlight',
            'ArrayOfSeatCode' => '\\ArrayType\\ArrayOfSeatCode',
            'SeatCode' => '\\StructType\\SeatCode',
            'ArrayOfCabin' => '\\ArrayType\\ArrayOfCabin',
            'Cabin' => '\\StructType\\Cabin',
            'ArrayOfSeatMap' => '\\ArrayType\\ArrayOfSeatMap',
            'SeatMap' => '\\StructType\\SeatMap',
            'ArrayOfSeatAssignment' => '\\ArrayType\\ArrayOfSeatAssignment',
            'SeatAssignment' => '\\StructType\\SeatAssignment',
            'ArrayOfSeatException' => '\\ArrayType\\ArrayOfSeatException',
            'SeatException' => '\\StructType\\SeatException',
            'ArrayOfSeatCharge' => '\\ArrayType\\ArrayOfSeatCharge',
            'SeatCharge' => '\\StructType\\SeatCharge',
            'ViewAirportRoutes' => '\\StructType\\ViewAirportRoutes',
            'ArrayOfRoute' => '\\ArrayType\\ArrayOfRoute',
            'Route' => '\\StructType\\Route',
            'ViewUpdateLidAircraftCollection' => '\\StructType\\ViewUpdateLidAircraftCollection',
            'ArrayOfViewUpdateLidAircraft' => '\\ArrayType\\ArrayOfViewUpdateLidAircraft',
            'ViewUpdateLidAircraft' => '\\StructType\\ViewUpdateLidAircraft',
            'ViewFlightScheduleInformation' => '\\StructType\\ViewFlightScheduleInformation',
            'ArrayOfFlightInformation' => '\\ArrayType\\ArrayOfFlightInformation',
            'FlightInformation' => '\\StructType\\FlightInformation',
            'ViewAllConfirmations' => '\\StructType\\ViewAllConfirmations',
            'ArrayOfBooking' => '\\ArrayType\\ArrayOfBooking',
            'Booking' => '\\StructType\\Booking',
            'ViewFlightStatus' => '\\StructType\\ViewFlightStatus',
            'ArrayOfSegments' => '\\ArrayType\\ArrayOfSegments',
            'Segments' => '\\StructType\\Segments',
            'ArrayOfLegdetails' => '\\ArrayType\\ArrayOfLegdetails',
            'Legdetails' => '\\StructType\\Legdetails',
            'ViewLogicalFlightInfo' => '\\StructType\\ViewLogicalFlightInfo',
            'ArrayOfLogicalFlightInfo' => '\\ArrayType\\ArrayOfLogicalFlightInfo',
            'LogicalFlightInfo' => '\\StructType\\LogicalFlightInfo',
            'ArrayOfPhysicalFlightInfo' => '\\ArrayType\\ArrayOfPhysicalFlightInfo',
            'PhysicalFlightInfo' => '\\StructType\\PhysicalFlightInfo',
            'ViewFlightSeatMap' => '\\StructType\\ViewFlightSeatMap',
            'ArrayOfPhysicalFlightMap' => '\\ArrayType\\ArrayOfPhysicalFlightMap',
            'PhysicalFlightMap' => '\\StructType\\PhysicalFlightMap',
            'PhysicalFlightSeatMapInfo' => '\\StructType\\PhysicalFlightSeatMapInfo',
            'ArrayOfCabinClassDisplay' => '\\ArrayType\\ArrayOfCabinClassDisplay',
            'CabinClassDisplay' => '\\StructType\\CabinClassDisplay',
            'ArrayOfDeckDisplay' => '\\ArrayType\\ArrayOfDeckDisplay',
            'DeckDisplay' => '\\StructType\\DeckDisplay',
            'ArrayOfSeatCabinDisplay' => '\\ArrayType\\ArrayOfSeatCabinDisplay',
            'SeatCabinDisplay' => '\\StructType\\SeatCabinDisplay',
            'SeatConfigurationDisplay' => '\\StructType\\SeatConfigurationDisplay',
            'ArrayOfRowDisplay' => '\\ArrayType\\ArrayOfRowDisplay',
            'RowDisplay' => '\\StructType\\RowDisplay',
            'ArrayOfRestrictionDisplay' => '\\ArrayType\\ArrayOfRestrictionDisplay',
            'RestrictionDisplay' => '\\StructType\\RestrictionDisplay',
            'ArrayOfSeatDisplay' => '\\ArrayType\\ArrayOfSeatDisplay',
            'SeatDisplay' => '\\StructType\\SeatDisplay',
            'SeatAssignDisplay' => '\\StructType\\SeatAssignDisplay',
            'ArrayOfSeatAttributeDisplay' => '\\ArrayType\\ArrayOfSeatAttributeDisplay',
            'SeatAttributeDisplay' => '\\StructType\\SeatAttributeDisplay',
            'HeldSeatDisplay' => '\\StructType\\HeldSeatDisplay',
            'ArrayOfSeatPriceOffer' => '\\ArrayType\\ArrayOfSeatPriceOffer',
            'SeatPriceOffer' => '\\StructType\\SeatPriceOffer',
            'ArrayOfSeatWBZoneDisplay' => '\\ArrayType\\ArrayOfSeatWBZoneDisplay',
            'SeatWBZoneDisplay' => '\\StructType\\SeatWBZoneDisplay',
            'RulesDisplay' => '\\StructType\\RulesDisplay',
            'EXRPAR' => '\\StructType\\EXRPAR',
            'RuleBase' => '\\StructType\\RuleBase',
            'EXRPTC' => '\\StructType\\EXRPTC',
            'EXRRSR' => '\\StructType\\EXRRSR',
            'MIAPSR' => '\\StructType\\MIAPSR',
            'SEATAJ' => '\\StructType\\SEATAJ',
            'SEATGT' => '\\StructType\\SEATGT',
            'ViewTrainSeatMap' => '\\StructType\\ViewTrainSeatMap',
            'ArrayOfPhysicalTrainMap' => '\\ArrayType\\ArrayOfPhysicalTrainMap',
            'PhysicalTrainMap' => '\\StructType\\PhysicalTrainMap',
            'ArrayOfRailCar' => '\\ArrayType\\ArrayOfRailCar',
            'RailCar' => '\\StructType\\RailCar',
            'ExceptionInformation.Exceptions' => '\\StructType\\ExceptionInformation_Exceptions',
            'ExceptionInformation.Exception' => '\\StructType\\ExceptionInformation_Exception',
            'ArrayOflong' => '\\ArrayType\\ArrayOflong',
            'ArrayOfstring' => '\\ArrayType\\ArrayOfstring',
            'ArrayOfint' => '\\ArrayType\\ArrayOfint',
        );
    }
}
