<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for EXRRSR StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:EXRRSR
 * @subpackage Structs
 */
class EXRRSR extends RuleBase
{
    /**
     * The Ssrs
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfstring
     */
    public $Ssrs;
    /**
     * Constructor method for EXRRSR
     * @uses EXRRSR::setSsrs()
     * @param \ArrayType\ArrayOfstring $ssrs
     */
    public function __construct(\ArrayType\ArrayOfstring $ssrs = null)
    {
        $this
            ->setSsrs($ssrs);
    }
    /**
     * Get Ssrs value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfstring|null
     */
    public function getSsrs()
    {
        return isset($this->Ssrs) ? $this->Ssrs : null;
    }
    /**
     * Set Ssrs value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfstring $ssrs
     * @return \StructType\EXRRSR
     */
    public function setSsrs(\ArrayType\ArrayOfstring $ssrs = null)
    {
        if (is_null($ssrs) || (is_array($ssrs) && empty($ssrs))) {
            unset($this->Ssrs);
        } else {
            $this->Ssrs = $ssrs;
        }
        return $this;
    }
}
