<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SEATGT StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:SEATGT
 * @subpackage Structs
 */
class SEATGT extends RuleBase
{
    /**
     * The Dependents
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfint
     */
    public $Dependents;
    /**
     * The LinkedPtcs
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfstring
     */
    public $LinkedPtcs;
    /**
     * Constructor method for SEATGT
     * @uses SEATGT::setDependents()
     * @uses SEATGT::setLinkedPtcs()
     * @param \ArrayType\ArrayOfint $dependents
     * @param \ArrayType\ArrayOfstring $linkedPtcs
     */
    public function __construct(\ArrayType\ArrayOfint $dependents = null, \ArrayType\ArrayOfstring $linkedPtcs = null)
    {
        $this
            ->setDependents($dependents)
            ->setLinkedPtcs($linkedPtcs);
    }
    /**
     * Get Dependents value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfint|null
     */
    public function getDependents()
    {
        return isset($this->Dependents) ? $this->Dependents : null;
    }
    /**
     * Set Dependents value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfint $dependents
     * @return \StructType\SEATGT
     */
    public function setDependents(\ArrayType\ArrayOfint $dependents = null)
    {
        if (is_null($dependents) || (is_array($dependents) && empty($dependents))) {
            unset($this->Dependents);
        } else {
            $this->Dependents = $dependents;
        }
        return $this;
    }
    /**
     * Get LinkedPtcs value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfstring|null
     */
    public function getLinkedPtcs()
    {
        return isset($this->LinkedPtcs) ? $this->LinkedPtcs : null;
    }
    /**
     * Set LinkedPtcs value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfstring $linkedPtcs
     * @return \StructType\SEATGT
     */
    public function setLinkedPtcs(\ArrayType\ArrayOfstring $linkedPtcs = null)
    {
        if (is_null($linkedPtcs) || (is_array($linkedPtcs) && empty($linkedPtcs))) {
            unset($this->LinkedPtcs);
        } else {
            $this->LinkedPtcs = $linkedPtcs;
        }
        return $this;
    }
}
