<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SeatAssignDisplay StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:SeatAssignDisplay
 * @subpackage Structs
 */
class SeatAssignDisplay extends AbstractStructBase
{
    /**
     * The PerOrgId
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $PerOrgId;
    /**
     * The PtcId
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $PtcId;
    /**
     * The TravelsWithInf
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $TravelsWithInf;
    /**
     * Constructor method for SeatAssignDisplay
     * @uses SeatAssignDisplay::setPerOrgId()
     * @uses SeatAssignDisplay::setPtcId()
     * @uses SeatAssignDisplay::setTravelsWithInf()
     * @param int $perOrgId
     * @param int $ptcId
     * @param bool $travelsWithInf
     */
    public function __construct($perOrgId = null, $ptcId = null, $travelsWithInf = null)
    {
        $this
            ->setPerOrgId($perOrgId)
            ->setPtcId($ptcId)
            ->setTravelsWithInf($travelsWithInf);
    }
    /**
     * Get PerOrgId value
     * @return int|null
     */
    public function getPerOrgId()
    {
        return $this->PerOrgId;
    }
    /**
     * Set PerOrgId value
     * @param int $perOrgId
     * @return \StructType\SeatAssignDisplay
     */
    public function setPerOrgId($perOrgId = null)
    {
        // validation for constraint: int
        if (!is_null($perOrgId) && !(is_int($perOrgId) || ctype_digit($perOrgId))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($perOrgId, true), gettype($perOrgId)), __LINE__);
        }
        $this->PerOrgId = $perOrgId;
        return $this;
    }
    /**
     * Get PtcId value
     * @return int|null
     */
    public function getPtcId()
    {
        return $this->PtcId;
    }
    /**
     * Set PtcId value
     * @param int $ptcId
     * @return \StructType\SeatAssignDisplay
     */
    public function setPtcId($ptcId = null)
    {
        // validation for constraint: int
        if (!is_null($ptcId) && !(is_int($ptcId) || ctype_digit($ptcId))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($ptcId, true), gettype($ptcId)), __LINE__);
        }
        $this->PtcId = $ptcId;
        return $this;
    }
    /**
     * Get TravelsWithInf value
     * @return bool|null
     */
    public function getTravelsWithInf()
    {
        return $this->TravelsWithInf;
    }
    /**
     * Set TravelsWithInf value
     * @param bool $travelsWithInf
     * @return \StructType\SeatAssignDisplay
     */
    public function setTravelsWithInf($travelsWithInf = null)
    {
        // validation for constraint: boolean
        if (!is_null($travelsWithInf) && !is_bool($travelsWithInf)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($travelsWithInf, true), gettype($travelsWithInf)), __LINE__);
        }
        $this->TravelsWithInf = $travelsWithInf;
        return $this;
    }
}
