<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ViewFlightSeatMap StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ViewFlightSeatMap
 * @subpackage Structs
 */
class ViewFlightSeatMap extends AbstractStructBase
{
    /**
     * The PhysicalFlights
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var \ArrayType\ArrayOfPhysicalFlightMap
     */
    public $PhysicalFlights;
    /**
     * The Rules
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var \StructType\RulesDisplay
     */
    public $Rules;
    /**
     * The Exceptions
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var \StructType\ExceptionInformation_Exceptions
     */
    public $Exceptions;
    /**
     * Constructor method for ViewFlightSeatMap
     * @uses ViewFlightSeatMap::setPhysicalFlights()
     * @uses ViewFlightSeatMap::setRules()
     * @uses ViewFlightSeatMap::setExceptions()
     * @param \ArrayType\ArrayOfPhysicalFlightMap $physicalFlights
     * @param \StructType\RulesDisplay $rules
     * @param \StructType\ExceptionInformation_Exceptions $exceptions
     */
    public function __construct(\ArrayType\ArrayOfPhysicalFlightMap $physicalFlights = null, \StructType\RulesDisplay $rules = null, \StructType\ExceptionInformation_Exceptions $exceptions = null)
    {
        $this
            ->setPhysicalFlights($physicalFlights)
            ->setRules($rules)
            ->setExceptions($exceptions);
    }
    /**
     * Get PhysicalFlights value
     * @return \ArrayType\ArrayOfPhysicalFlightMap|null
     */
    public function getPhysicalFlights()
    {
        return $this->PhysicalFlights;
    }
    /**
     * Set PhysicalFlights value
     * @param \ArrayType\ArrayOfPhysicalFlightMap $physicalFlights
     * @return \StructType\ViewFlightSeatMap
     */
    public function setPhysicalFlights(\ArrayType\ArrayOfPhysicalFlightMap $physicalFlights = null)
    {
        $this->PhysicalFlights = $physicalFlights;
        return $this;
    }
    /**
     * Get Rules value
     * @return \StructType\RulesDisplay|null
     */
    public function getRules()
    {
        return $this->Rules;
    }
    /**
     * Set Rules value
     * @param \StructType\RulesDisplay $rules
     * @return \StructType\ViewFlightSeatMap
     */
    public function setRules(\StructType\RulesDisplay $rules = null)
    {
        $this->Rules = $rules;
        return $this;
    }
    /**
     * Get Exceptions value
     * @return \StructType\ExceptionInformation_Exceptions|null
     */
    public function getExceptions()
    {
        return $this->Exceptions;
    }
    /**
     * Set Exceptions value
     * @param \StructType\ExceptionInformation_Exceptions $exceptions
     * @return \StructType\ViewFlightSeatMap
     */
    public function setExceptions(\StructType\ExceptionInformation_Exceptions $exceptions = null)
    {
        $this->Exceptions = $exceptions;
        return $this;
    }
}
